<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		bulkupload
 */

/**
 * Module page class.
 */
class Module_admin_bulkupload
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=2;
		$info['locked']=false;
		return $info;
	}

	/**
	 * Standard modular entry-point finder function.
	 *
	 * @return ?array	A map of entry points (type-code=>language-code) (NULL: disabled).
	 */
	function get_entry_points()
	{
		return array('!'=>'BULK_UPLOAD');
	}

	/**
	 * Standard modular run function.
	 *
	 * @return tempcode	The result of execution.
	 */
	function run()
	{
		require_lang('bulkupload');

		$GLOBALS['HELPER_PANEL_PIC']='pagepics/bulkuploadassistant';
		$GLOBALS['HELPER_PANEL_TUTORIAL']='tut_adv_comcode';
		$GLOBALS['HELPER_PANEL_TEXT']=comcode_lang_string('DOC_BULK_UPLOAD');

		$title=get_screen_title('BULK_UPLOAD');

		$parameter=post_param('parameter','');
		require_code('form_templates');
		if ($parameter=='')
		{
			$post_url=build_url(array('page'=>'_SELF'),'_SELF');
			$text=paragraph(do_lang_tempcode('BULK_UPLOAD_HELP'));
			$submit_name=do_lang_tempcode('BULK_UPLOAD');
			$fields=form_input_line(do_lang_tempcode('DIRECTORY'),do_lang_tempcode('DIRECTORY_BULK'),'parameter','uploads/attachments/'.date('Y-m-d',utctime_to_usertime()),true);

			return do_template('FORM_SCREEN',array('_GUID'=>'77a2ca460745145d8a1d18cf24971fea','SKIP_VALIDATION'=>true,'HIDDEN'=>'','FIELDS'=>$fields,'URL'=>$post_url,'TITLE'=>$title,'TEXT'=>$text,'SUBMIT_NAME'=>$submit_name));
		} else
		{
			breadcrumb_set_parents(array(array('_SELF:_SELF:misc',do_lang_tempcode('BULK_UPLOAD'))));
			breadcrumb_set_self(do_lang_tempcode('_RESULTS'));

			$out=$this->do_dir(get_custom_file_base().'/'.filter_naughty($parameter,true));
			if ($out->is_empty()) inform_exit(do_lang_tempcode('NO_FILES'));

			return do_template('BULK_HELPER_RESULTS_SCREEN',array('_GUID'=>'5d373553cf21a58f15006bd4e600a9ee','TITLE'=>$title,'RESULTS'=>$out));
		}
	}

	/**
	 * Scan a directory for files, and put them into the tempcode as an entry in the visual list.
	 *
	 * @param  PATH				The directory path
	 * @return tempcode			The visual list of files
	 */
	function do_dir($path)
	{
		$out=new ocp_tempcode();

		$files_here=array();
		$dirs_here=array();

		$handle=@opendir($path);
		if ($handle!==false)
		{
			while (false!==($file=readdir($handle)))
			{
				if (!should_ignore_file($file,IGNORE_ACCESS_CONTROLLERS | IGNORE_HIDDEN_FILES))
				{
					if (is_file($path.'/'.$file))
					{
						$filefull=substr($path,strlen(get_file_base().'/')).'/'.$file;

						$files_here[]=$filefull;
					} else
					{
						$dirs_here[]=$path.'/'.$file;
					}
				}
			}
			closedir($handle);
		} else warn_exit(do_lang_tempcode('DIRECTORY_NOT_FOUND',escape_html($path)));

		sort($files_here);
		foreach ($files_here as $filefull)
		{
			$out->attach(do_template('BULK_HELPER_ENTRY',array('_GUID'=>'f57ec94c57b0ef0096c80a6c463f31d3','FILEFULL'=>$filefull)));
		}

		sort($dirs_here);
		foreach ($dirs_here as $dir)
		{
			$out->attach($this->do_dir($dir));
		}

		return $out;
	}

}


