<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		core_adminzone_frontpage
 */

class Hook_checklist_copyright
{

	/**
	 * Standard modular run function.
	 *
	 * @return array		An array of tuples: The task row to show, the number of seconds until it is due (or NULL if not on a timer), the number of things to sort out (or NULL if not on a queue), The name of the config option that controls the schedule (or NULL if no option).
	 */
	function run()
	{
		$copyright=get_option('copyright');

		$matches=array();
		if ((preg_match('#[^\d]\d\d\d\d-(\d\d(\d\d)?)([^\d]|$)#',$copyright,$matches)==0) && (preg_match('#[^\d](\d\d(\d\d)?)([^\d]|$)#',$copyright,$matches)==0))
			return array();

		if ((intval($matches[1])<intval(date('Y'))) && (intval($matches[1])<intval(substr(date('Y'),2))))
		{
			$status=0;
		} else
		{
			$status=1;
			return array(); // We want to forget about this check entry if it's done for the year
		}
		$_status=($status==0)?do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_0'):do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_1');
		$url=build_url(array('page'=>'admin_config','type'=>'category','id'=>'SITE'),'adminzone');
		$tpl=do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM',array('URL'=>'','STATUS'=>$_status,'TASK'=>urlise_lang(do_lang('NAG_COPYRIGHT_DATE'),$url)));
		return array(array($tpl,($status==0)?-1:0,NULL,NULL));
	}

}


