<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		news
 */

class Hook_checklist_news
{

	/**
	 * Standard modular run function.
	 *
	 * @return array		An array of tuples: The task row to show, the number of seconds until it is due (or NULL if not on a timer), the number of things to sort out (or NULL if not on a queue), The name of the config option that controls the schedule (or NULL if no option).
	 */
	function run()
	{
		if (!addon_installed('news')) return array();

		if (get_option('news_update_time')=='') return array();

		require_lang('news');

		$date=$GLOBALS['SITE_DB']->query_value_null_ok('news n JOIN '.$GLOBALS['SITE_DB']->get_table_prefix().'news_categories c ON n.news_category=c.id','MAX(date_and_time)',array('validated'=>1,'nc_owner'=>NULL));

		$limit_hours=intval(get_option('news_update_time'));

		$seconds_ago=mixed();
		if (!is_null($date))
		{
			$seconds_ago=time()-$date;
			$status=($seconds_ago>$limit_hours*60*60)?0:1;
		} else
		{
			$status=0;
		}

		$_status=($status==0)?do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_0'):do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_1');

		$config_row=$GLOBALS['SITE_DB']->query_select('config',array('the_page','section'),array('the_name'=>'news_update_time'),'',1);
		if (array_key_exists(0,$config_row))
		{
			$_config_url=build_url(array('page'=>'admin_config','type'=>'category','id'=>$config_row[0]['the_page']),get_module_zone('admin_config'));
			$config_url=$_config_url->evaluate();
			$config_url.='#group_'.$config_row[0]['section'];
		} else $config_url=NULL;

		$url=build_url(array('page'=>'cms_news','type'=>'ad'),get_module_zone('cms_news'));
		list($info,$seconds_due_in)=staff_checklist_time_ago_and_due($seconds_ago,$limit_hours);
		$tpl=do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM',array('_GUID'=>'dd14f34eafa4f24c4c173c195cd84fe3','CONFIG_URL'=>$config_url,'URL'=>$url,'STATUS'=>$_status,'TASK'=>do_lang_tempcode('ADD_NEWS'),'INFO'=>$info));
		return array(array($tpl,$seconds_due_in,NULL,'news_update_time'));
	}

}


