<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		downloads
 */

class Hook_whats_news_downloads
{

	/**
	 * Standard modular run function for newsletter hooks.
	 *
	 * @return ?array				Tuple of result details: HTML list of all types that can be choosed, title for selection list (NULL: disabled)
	 */
	function choose_categories()
	{
		if (!addon_installed('downloads')) return NULL;

		require_lang('downloads');

		require_code('downloads');
		return array(nice_get_download_category_tree(),do_lang('SECTION_DOWNLOADS'));
	}

	/**
	 * Standard modular run function for newsletter hooks.
	 *
	 * @param  TIME				The time that the entries found must be newer than
	 * @param  LANGUAGE_NAME	The language the entries found must be in
	 * @param  string				Category filter to apply
	 * @return array				Tuple of result details
	 */
	function run($cutoff_time,$lang,$filter)
	{
		if (!addon_installed('downloads')) return array();

		require_lang('downloads');

		$new=new ocp_tempcode();

		require_code('ocfiltering');
		$or_list=ocfilter_to_sqlfragment($filter,'category_id');
		$rows=$GLOBALS['SITE_DB']->query('SELECT name,description,id,add_date,submitter FROM '.get_table_prefix().'download_downloads WHERE validated=1 AND add_date>'.strval((integer)$cutoff_time).' AND ('.$or_list.') ORDER BY add_date DESC',300);
		if (count($rows)==300) return array();
		foreach ($rows as $row)
		{
			$_url=build_url(array('page'=>'downloads','type'=>'entry','id'=>$row['id']),get_module_zone('downloads'),NULL,false,false,true);
			$url=$_url->evaluate();
			$name=get_translated_text($row['name'],NULL,$lang);
			$description=get_translated_text($row['description'],NULL,$lang);
			$member_id=(is_guest($row['submitter']))?NULL:strval($row['submitter']);
			$new->attach(do_template('NEWSLETTER_NEW_RESOURCE_FCOMCODE',array('_GUID'=>'bbd85ed54500b9d6df998e3c835b45e9','MEMBER_ID'=>$member_id,'URL'=>$url,'NAME'=>$name,'DESCRIPTION'=>$description)));
		}

		return array($new,do_lang('SECTION_DOWNLOADS','','','',$lang));
	}

}


