<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		ocf_forum
 */

class Hook_content_meta_aware_forum
{

	/**
	 * Standard modular info function for content_meta_aware hooks. Allows progmattic identification of ocPortal entity model (along with db_meta table contents).
	 *
	 * @return ?array	Map of award content-type info (NULL: disabled).
	 */
	function info()
	{
		return array(
			'content_type_label'=>'ocf:FORUM',

			'table'=>'f_forums',
			'id_field'=>'id',
			'id_field_numeric'=>true,
			'parent_category_field'=>'f_parent_forum',
			'parent_category_meta_aware_type'=>'forum',
			'title_field'=>'f_name',
			'title_field_dereference'=>false,

			'is_category'=>true,
			'is_entry'=>false,
			'seo_type_code'=>NULL,
			'feedback_type_code'=>NULL,
			'permissions_type_code'=>'forums', // NULL if has no permissions
			'view_pagelink_pattern'=>'_SEARCH:forumview:misc:_WILD',
			'edit_pagelink_pattern'=>'_SEARCH:admin_ocf_forums:_ec:_WILD',
			'view_category_pagelink_pattern'=>'_SEARCH:forumview:misc:_WILD',
			'support_url_monikers'=>true,
			'search_hook'=>NULL,
			'submitter_field'=>NULL,
			'add_time_field'=>NULL,
			'edit_time_field'=>NULL,
			'validated_field'=>NULL,

			'addon_name'=>'ocf_forum',

			'module'=>'forumview',
		);
	}

}
