<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		core_ocf
 */

class Hook_Profiles_Tabs_Edit_profile
{

	/**
	 * Find whether this hook is active.
	 *
	 * @param  MEMBER			The ID of the member who is being viewed
	 * @param  MEMBER			The ID of the member who is doing the viewing
	 * @return boolean		Whether this hook is active
	 */
	function is_active($member_id_of,$member_id_viewing)
	{
		if (($member_id_of==$member_id_viewing) || (has_specific_permission($member_id_viewing,'assume_any_member')) || (has_specific_permission($member_id_viewing,'member_maintenance')))
		{
			$mini_mode=false;
			$groups=$GLOBALS['OCF_DRIVER']->get_members_groups($member_id_of);
			$_custom_fields=ocf_get_all_custom_fields_match(
				$groups,
				($mini_mode || (is_null($member_id_of)) || ($member_id_of==$member_id_viewing) || (has_specific_permission($member_id_viewing,'view_any_profile_field')))?NULL:1, // public view
				($mini_mode || (is_null($member_id_of)) || ($member_id_of!=$member_id_viewing) || (has_specific_permission($member_id_viewing,'view_any_profile_field')))?NULL:1, // owner view
				($mini_mode || (is_null($member_id_of)) || ($member_id_of!=$member_id_viewing) || (has_specific_permission($member_id_viewing,'view_any_profile_field')))?NULL:1, // owner set
				NULL,
				NULL,
				NULL,
				0,
				$mini_mode?true:NULL // show on join form
			);
			if (count($_custom_fields)==0) return false;
			return true;
		}
		return false;
	}

	/**
	 * Standard modular render function for profile tabs edit hooks.
	 *
	 * @param  MEMBER			The ID of the member who is being viewed
	 * @param  MEMBER			The ID of the member who is doing the viewing
	 * @param  boolean		Whether to leave the tab contents NULL, if tis hook supports it, so that AJAX can load it later
	 * @return ?array			A tuple: The tab title, the tab body text (may be blank), the tab fields, extra Javascript (may be blank) the suggested tab order, hidden fields (optional) (NULL: if $leave_to_ajax_if_possible was set)
	 */
	function render_tab($member_id_of,$member_id_viewing,$leave_to_ajax_if_possible=false)
	{
		$order=10;

		// NB: Actualiser is handled in settings.php

		if ($leave_to_ajax_if_possible) return NULL;

		// UI

		require_code('form_templates');

		$title=do_lang_tempcode('PROFILE');

		$custom_fields=ocf_get_custom_fields_member($member_id_of);

		require_code('ocf_members_action2');
		list($fields,$hidden)=ocf_get_member_fields_profile(false,$member_id_of,NULL,$custom_fields);

		$redirect=get_param('redirect',NULL);
		if (!is_null($redirect))
			$hidden->attach(form_input_hidden('redirect',$redirect));

		$javascript='';

		$text='';

		return array($title,$fields,$text,$javascript,$order,$hidden);
	}

}


